Package com.sas.metadata.remote

# Interface Cube

All Superinterfaces:
  `Classifier`, `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Cube extends Classifier
A logical set of data that is organized and structured in a hierarchical, multidimensional arrangement. A cube is a directory structure, not a single file. A cube includes measures, and it can have numerous dimensions and levels of data.

Attributes of Cube are:

- `CubeType`
- `CubeName`

Associations of Cube are:

- `Aggregations`
- `AssociatedFile`
- `Dimensions`
- `Hierarchies`
- `ParentCubes`
- `PreviousGeneration`
- `ReachThruTables`
- `AssociatedOLAPSchema`
- `Formulas`
- `Measures`
- `NextGeneration`
- `SubCubes`

## Usage

To create an instance of this Cube, use the `factory` create methods.
Example: create a Cube with name "Cube_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Cube myObject = (Cube) factory.createComplexMetadataObject(objectStore, "Cube_Object", MetadataObjects.CUBE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_AGGREGATIONS_NAME`
  Constant used for the name of the Aggregations association.
  `static final String`
  `ASSOCIATION_ASSOCIATEDFILE_NAME`
  Constant used for the name of the AssociatedFile association.
  `static final String`
  `ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME`
  Constant used for the name of the AssociatedOLAPSchema association.
  `static final String`
  `ASSOCIATION_DIMENSIONS_NAME`
  Constant used for the name of the Dimensions association.
  `static final String`
  `ASSOCIATION_FORMULAS_NAME`
  Constant used for the name of the Formulas association.
  `static final String`
  `ASSOCIATION_HIERARCHIES_NAME`
  Constant used for the name of the Hierarchies association.
  `static final String`
  `ASSOCIATION_MEASURES_NAME`
  Constant used for the name of the Measures association.
  `static final String`
  `ASSOCIATION_NEXTGENERATION_NAME`
  Constant used for the name of the NextGeneration association.
  `static final String`
  `ASSOCIATION_PARENTCUBES_NAME`
  Constant used for the name of the ParentCubes association.
  `static final String`
  `ASSOCIATION_PREVIOUSGENERATION_NAME`
  Constant used for the name of the PreviousGeneration association.
  `static final String`
  `ASSOCIATION_REACHTHRUTABLES_NAME`
  Constant used for the name of the ReachThruTables association.
  `static final String`
  `ASSOCIATION_SUBCUBES_NAME`
  Constant used for the name of the SubCubes association.
  `static final String`
  `ATTRIBUTE_CUBENAME_NAME`
  Constant used for the name of the CubeName attribute.
  `static final String`
  `ATTRIBUTE_CUBETYPE_NAME`
  Constant used for the name of the CubeType attribute.

  ### Fields inherited from interface com.sas.metadata.remote.Classifier

  `ASSOCIATION_SOURCECLASSIFIERMAPS_NAME, ASSOCIATION_TARGETCLASSIFIERMAPS_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getAggregations()`
  Gets the AssociationList of `Aggregations`
  `AssociationList`
  `getAggregations(boolean fGoToServer)`
  Gets the Associationlist of `Aggregations`
  `File`
  `getAssociatedFile()`
  Gets the `File` for `AssociatedFile`
  `AssociationList`
  `getAssociatedFiles()`
  Gets the AssociationList of `AssociatedFiles`
  `AssociationList`
  `getAssociatedFiles(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedFiles`
  `OLAPSchema`
  `getAssociatedOLAPSchema()`
  Gets the `OLAPSchema` for `AssociatedOLAPSchema`
  `AssociationList`
  `getAssociatedOLAPSchemas()`
  Gets the Association list of `AssociatedOLAPSchemas`
  `AssociationList`
  `getAssociatedOLAPSchemas(boolean fGoToServer)`
  Gets the Associationlist of `AssociatedOLAPSchemas`
  `String`
  `getCubeName()`
  Gets the `String` value of `CubeName`
  `int`
  `getCubeNameMaxLength()`
  Gets the maximum length of `CubeName`
  `int`
  `getCubeNameState()`
  Gets the Metadata State of `CubeName`
  `String`
  `getCubeType()`
  Gets the `String` value of `CubeType`
  `int`
  `getCubeTypeMaxLength()`
  Gets the maximum length of `CubeType`
  `int`
  `getCubeTypeState()`
  Gets the Metadata State of `CubeType`
  `AssociationList`
  `getDimensions()`
  Gets the AssociationList of `Dimensions`
  `AssociationList`
  `getDimensions(boolean fGoToServer)`
  Gets the Associationlist of `Dimensions`
  `AssociationList`
  `getFormulas()`
  Gets the Association list of `Formulas`
  `AssociationList`
  `getFormulas(boolean fGoToServer)`
  Gets the Associationlist of `Formulas`
  `AssociationList`
  `getHierarchies()`
  Gets the AssociationList of `Hierarchies`
  `AssociationList`
  `getHierarchies(boolean fGoToServer)`
  Gets the Associationlist of `Hierarchies`
  `AssociationList`
  `getMeasures()`
  Gets the Association list of `Measures`
  `AssociationList`
  `getMeasures(boolean fGoToServer)`
  Gets the Associationlist of `Measures`
  `Cube`
  `getNextGeneration()`
  Gets the `Cube` for `NextGeneration`
  `AssociationList`
  `getNextGenerations()`
  Gets the Association list of `NextGenerations`
  `AssociationList`
  `getNextGenerations(boolean fGoToServer)`
  Gets the Associationlist of `NextGenerations`
  `AssociationList`
  `getParentCubes()`
  Gets the AssociationList of `ParentCubes`
  `AssociationList`
  `getParentCubes(boolean fGoToServer)`
  Gets the Associationlist of `ParentCubes`
  `Cube`
  `getPreviousGeneration()`
  Gets the `Cube` for `PreviousGeneration`
  `AssociationList`
  `getPreviousGenerations()`
  Gets the AssociationList of `PreviousGenerations`
  `AssociationList`
  `getPreviousGenerations(boolean fGoToServer)`
  Gets the Associationlist of `PreviousGenerations`
  `AssociationList`
  `getReachThruTables()`
  Gets the AssociationList of `ReachThruTables`
  `AssociationList`
  `getReachThruTables(boolean fGoToServer)`
  Gets the Associationlist of `ReachThruTables`
  `AssociationList`
  `getSubCubes()`
  Gets the Association list of `SubCubes`
  `AssociationList`
  `getSubCubes(boolean fGoToServer)`
  Gets the Associationlist of `SubCubes`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `Aggregations`
  `AssociatedFile`
  `Dimensions`
  `Hierarchies`
  `ParentCubes`
  `PreviousGeneration`
  `ReachThruTables`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAggregations(AssociationList list)`
  Sets the `Aggregations` list to be `list`.
  `void`
  `setAggregations(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setAssociatedFile(File inObject)`
  Sets the `AssociatedFiles` list 0th element to be `inObject`.
  `void`
  `setAssociatedFiles(AssociationList list)`
  Sets the `AssociatedFiles` list to be `list`.
  `void`
  `setAssociatedFiles(AssociationList list, int state)`
  Sets the `AssociatedFiles` list to be `list`.
  `void`
  `setAssociatedOLAPSchema(OLAPSchema inObject)`
  Sets the `AssociatedOLAPSchemas` list 0th element to be `inObject`.
  `void`
  `setAssociatedOLAPSchemas(AssociationList list)`
  Sets the `AssociatedOLAPSchemas` list to be `list`.
  `void`
  `setAssociatedOLAPSchemas(AssociationList list, int state)`
  Sets the `AssociatedOLAPSchemas` list to be `list`.
  `void`
  `setCubeName(String inCubeName)`
  Sets the `CubeName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCubeName(String inCubeName, int state)`
  Sets the `CubeName` Metadata State.
  `void`
  `setCubeNameState(int state)`
  Sets the Metadata State of `CubeName`.
  `void`
  `setCubeType(String inCubeType)`
  Sets the `CubeType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setCubeType(String inCubeType, int state)`
  Sets the `CubeType` Metadata State.
  `void`
  `setCubeTypeState(int state)`
  Sets the Metadata State of `CubeType`.
  `void`
  `setDimensions(AssociationList list)`
  Sets the `Dimensions` list to be `list`.
  `void`
  `setDimensions(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setFormulas(AssociationList list)`
  Sets the `Formulas` list to be `list`.
  `void`
  `setFormulas(AssociationList inObjects, int state)`
  Sets the entire Formulas list to match the passed in AssociationList, sets the state of the Formulas
  `void`
  `setHierarchies(AssociationList list)`
  Sets the `Hierarchies` list to be `list`.
  `void`
  `setHierarchies(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setMeasures(AssociationList list)`
  Sets the `Measures` list to be `list`.
  `void`
  `setMeasures(AssociationList inObjects, int state)`
  Sets the entire Measures list to match the passed in AssociationList, sets the state of the Measures
  `void`
  `setNextGeneration(Cube inObject)`
  Sets the `NextGenerations` list 0th element to be `inObject`.
  `void`
  `setNextGenerations(AssociationList list)`
  Sets the `NextGenerations` list to be `list`.
  `void`
  `setNextGenerations(AssociationList list, int state)`
  Sets the `NextGenerations` list to be `list`.
  `void`
  `setParentCubes(AssociationList list)`
  Sets the `ParentCubes` list to be `list`.
  `void`
  `setParentCubes(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setPreviousGeneration(Cube inObject)`
  Sets the `PreviousGenerations` list 0th element to be `inObject`.
  `void`
  `setPreviousGenerations(AssociationList list)`
  Sets the `PreviousGenerations` list to be `list`.
  `void`
  `setPreviousGenerations(AssociationList list, int state)`
  Sets the `PreviousGenerations` list to be `list`.
  `void`
  `setReachThruTables(AssociationList list)`
  Sets the `ReachThruTables` list to be `list`.
  `void`
  `setReachThruTables(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setSubCubes(AssociationList list)`
  Sets the `SubCubes` list to be `list`.
  `void`
  `setSubCubes(AssociationList inObjects, int state)`
  Sets the entire SubCubes list to match the passed in AssociationList, sets the state of the SubCubes

  ### Methods inherited from interface com.sas.metadata.remote.Classifier

  `getSourceClassifierMaps, getSourceClassifierMaps, getTargetClassifierMaps, getTargetClassifierMaps, setSourceClassifierMaps, setSourceClassifierMaps, setTargetClassifierMaps, setTargetClassifierMaps`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_CUBETYPE_NAME

    static final String ATTRIBUTE_CUBETYPE_NAME
    Constant used for the name of the CubeType attribute.

    CubeType: This attribute describes the persistence of the data in the multidimensional object. Valid values are: MOLAP, HOLAP, VIRTUAL.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_CUBENAME_NAME

    static final String ATTRIBUTE_CUBENAME_NAME
    Constant used for the name of the CubeName attribute.

    CubeName: The name of the cube used by the OLAP server to access the Cube. The Name attribute inherited from Root is the logical or display name.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_AGGREGATIONS_NAME

    static final String ASSOCIATION_AGGREGATIONS_NAME
    Constant used for the name of the Aggregations association.

    Aggregations: The aggregations in a cube.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDFILE_NAME

    static final String ASSOCIATION_ASSOCIATEDFILE_NAME
    Constant used for the name of the AssociatedFile association.

    AssociatedFile: The file that contains the information used for the cube object.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_DIMENSIONS_NAME

    static final String ASSOCIATION_DIMENSIONS_NAME
    Constant used for the name of the Dimensions association.

    Dimensions: The dimensions associated with this cube.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_HIERARCHIES_NAME

    static final String ASSOCIATION_HIERARCHIES_NAME
    Constant used for the name of the Hierarchies association.

    Hierarchies: The list of hierarchies in this cube.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PARENTCUBES_NAME

    static final String ASSOCIATION_PARENTCUBES_NAME
    Constant used for the name of the ParentCubes association.

    ParentCubes: The cubes that consume this cube.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PREVIOUSGENERATION_NAME

    static final String ASSOCIATION_PREVIOUSGENERATION_NAME
    Constant used for the name of the PreviousGeneration association.

    PreviousGeneration: The previous generation of this cube.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_REACHTHRUTABLES_NAME

    static final String ASSOCIATION_REACHTHRUTABLES_NAME
    Constant used for the name of the ReachThruTables association.

    ReachThruTables: The tables that contain reach thru data.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME

    static final String ASSOCIATION_ASSOCIATEDOLAPSCHEMA_NAME
    Constant used for the name of the AssociatedOLAPSchema association.

    AssociatedOLAPSchema: *Unknown*

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_FORMULAS_NAME

    static final String ASSOCIATION_FORMULAS_NAME
    Constant used for the name of the Formulas association.

    Formulas: The list of global formulas for this cube.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_MEASURES_NAME

    static final String ASSOCIATION_MEASURES_NAME
    Constant used for the name of the Measures association.

    Measures: *Unknown*

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_NEXTGENERATION_NAME

    static final String ASSOCIATION_NEXTGENERATION_NAME
    Constant used for the name of the NextGeneration association.

    NextGeneration: The next generation for this cube.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SUBCUBES_NAME

    static final String ASSOCIATION_SUBCUBES_NAME
    Constant used for the name of the SubCubes association.

    SubCubes: The sub-cubes that comprise this cube.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `Classifier`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `Aggregations`
    `AssociatedFile`
    `Dimensions`
    `Hierarchies`
    `ParentCubes`
    `PreviousGeneration`
    `ReachThruTables`
    Specified by:
      `initializePredObjects` in interface `Classifier`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCubeType

    String getCubeType() throws RemoteException
    Gets the `String` value of `CubeType`
    Returns:
      The `CubeType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCubeTypeState

    int getCubeTypeState() throws RemoteException
    Gets the Metadata State of `CubeType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCubeTypeMaxLength

    int getCubeTypeMaxLength() throws RemoteException
    Gets the maximum length of `CubeType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCubeName

    String getCubeName() throws RemoteException
    Gets the `String` value of `CubeName`
    Returns:
      The `CubeName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCubeNameState

    int getCubeNameState() throws RemoteException
    Gets the Metadata State of `CubeName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getCubeNameMaxLength

    int getCubeNameMaxLength() throws RemoteException
    Gets the maximum length of `CubeName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAggregations

    AssociationList getAggregations() throws RemoteException, MdException
    Gets the AssociationList of `Aggregations`
    Returns:
      Returns the AssociationList of `Aggregations` which can be of type:
      Aggregation
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedFiles

    AssociationList getAssociatedFiles() throws RemoteException, MdException
    Gets the AssociationList of `AssociatedFiles`
    Returns:
      Returns the AssociationList of `AssociatedFiles` which can be of type:
      File
      ArchiveFile
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getAssociatedFile

    File getAssociatedFile() throws RemoteException, MdException
    Gets the `File` for `AssociatedFile`
    Returns:
      The `File` ( `null` if not set) of `AssociatedFile`which can be of type:
      File
      ArchiveFile
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDimensions

    AssociationList getDimensions() throws RemoteException, MdException
    Gets the AssociationList of `Dimensions`
    Returns:
      Returns the AssociationList of `Dimensions` which can be of type:
      Dimension
      SharedDimension
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getHierarchies

    AssociationList getHierarchies() throws RemoteException, MdException
    Gets the AssociationList of `Hierarchies`
    Returns:
      Returns the AssociationList of `Hierarchies` which can be of type:
      Hierarchy
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getParentCubes

    AssociationList getParentCubes() throws RemoteException, MdException
    Gets the AssociationList of `ParentCubes`
    Returns:
      Returns the AssociationList of `ParentCubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPreviousGenerations

    AssociationList getPreviousGenerations() throws RemoteException, MdException
    Gets the AssociationList of `PreviousGenerations`
    Returns:
      Returns the AssociationList of `PreviousGenerations` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getPreviousGeneration

    Cube getPreviousGeneration() throws RemoteException, MdException
    Gets the `Cube` for `PreviousGeneration`
    Returns:
      The `Cube` ( `null` if not set) of `PreviousGeneration`which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getReachThruTables

    AssociationList getReachThruTables() throws RemoteException, MdException
    Gets the AssociationList of `ReachThruTables`
    Returns:
      Returns the AssociationList of `ReachThruTables` which can be of type:
      PhysicalTable
      WorkTable
      SecuredTable
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedOLAPSchemas

    AssociationList getAssociatedOLAPSchemas() throws RemoteException, MdException
    Gets the Association list of `AssociatedOLAPSchemas`
    Returns:
      The AssociationList of `AssociatedOLAPSchemas` which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedOLAPSchema

    OLAPSchema getAssociatedOLAPSchema() throws RemoteException, MdException
    Gets the `OLAPSchema` for `AssociatedOLAPSchema`
    Returns:
      The `OLAPSchema` ( `null` if not set ) of `AssociatedOLAPSchema` which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getFormulas

    AssociationList getFormulas() throws RemoteException, MdException
    Gets the Association list of `Formulas`
    Returns:
      The AssociationList of `Formulas` which can be of type:
      GlobalFormula
      NamedSet
      CalculatedMember
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getMeasures

    AssociationList getMeasures() throws RemoteException, MdException
    Gets the Association list of `Measures`
    Returns:
      The AssociationList of `Measures` which can be of type:
      Measure
      CalculatedMeasure
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getNextGenerations

    AssociationList getNextGenerations() throws RemoteException, MdException
    Gets the Association list of `NextGenerations`
    Returns:
      The AssociationList of `NextGenerations` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getNextGeneration

    Cube getNextGeneration() throws RemoteException, MdException
    Gets the `Cube` for `NextGeneration`
    Returns:
      The `Cube` ( `null` if not set ) of `NextGeneration` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSubCubes

    AssociationList getSubCubes() throws RemoteException, MdException
    Gets the Association list of `SubCubes`
    Returns:
      The AssociationList of `SubCubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAggregations

    AssociationList getAggregations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Aggregations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Aggregations` which can be of type:
      Aggregation
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedFiles

    AssociationList getAssociatedFiles(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedFiles`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `AssociatedFiles` which can be of type:
      File
      ArchiveFile
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getDimensions

    AssociationList getDimensions(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Dimensions`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Dimensions` which can be of type:
      Dimension
      SharedDimension
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getHierarchies

    AssociationList getHierarchies(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Hierarchies`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Hierarchies` which can be of type:
      Hierarchy
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getParentCubes

    AssociationList getParentCubes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ParentCubes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `ParentCubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPreviousGenerations

    AssociationList getPreviousGenerations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `PreviousGenerations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `PreviousGenerations` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getReachThruTables

    AssociationList getReachThruTables(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ReachThruTables`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `ReachThruTables` which can be of type:
      PhysicalTable
      WorkTable
      SecuredTable
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getAssociatedOLAPSchemas

    AssociationList getAssociatedOLAPSchemas(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `AssociatedOLAPSchemas`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `AssociatedOLAPSchemas` which can be of type:
      OLAPSchema
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getFormulas

    AssociationList getFormulas(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Formulas`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Formulas` which can be of type:
      GlobalFormula
      NamedSet
      CalculatedMember
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getMeasures

    AssociationList getMeasures(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Measures`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Measures` which can be of type:
      Measure
      CalculatedMeasure
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getNextGenerations

    AssociationList getNextGenerations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `NextGenerations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `NextGenerations` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSubCubes

    AssociationList getSubCubes(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `SubCubes`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `SubCubes` which can be of type:
      Cube
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setCubeType

    void setCubeType(String inCubeType) throws RemoteException
    Sets the `CubeType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCubeType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubeType

    void setCubeType(String inCubeType, int state) throws RemoteException
    Sets the `CubeType` Metadata State.
    Parameters:
      `inCubeType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubeTypeState

    void setCubeTypeState(int state) throws RemoteException
    Sets the Metadata State of `CubeType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubeName

    void setCubeName(String inCubeName) throws RemoteException
    Sets the `CubeName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inCubeName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubeName

    void setCubeName(String inCubeName, int state) throws RemoteException
    Sets the `CubeName` Metadata State.
    Parameters:
      `inCubeName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setCubeNameState

    void setCubeNameState(int state) throws RemoteException
    Sets the Metadata State of `CubeName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAggregations

    void setAggregations(AssociationList list) throws RemoteException
    Sets the `Aggregations` list to be `list`. Objects of which can be of type:
    Aggregation
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAggregations

    void setAggregations(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedFiles

    void setAssociatedFiles(AssociationList list) throws RemoteException
    Sets the `AssociatedFiles` list to be `list`. Object of which can be of type:
    File
    ArchiveFile
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedFiles

    void setAssociatedFiles(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedFiles` list to be `list`. Object of which can be of type:
    File
    ArchiveFile
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedFile

    void setAssociatedFile(File inObject) throws RemoteException
    Sets the `AssociatedFiles` list 0th element to be `inObject`.
    Parameters:
      `inObject` - File
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDimensions

    void setDimensions(AssociationList list) throws RemoteException
    Sets the `Dimensions` list to be `list`. Objects of which can be of type:
    Dimension
    SharedDimension
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDimensions

    void setDimensions(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchies

    void setHierarchies(AssociationList list) throws RemoteException
    Sets the `Hierarchies` list to be `list`. Objects of which can be of type:
    Hierarchy
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHierarchies

    void setHierarchies(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setParentCubes

    void setParentCubes(AssociationList list) throws RemoteException
    Sets the `ParentCubes` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setParentCubes

    void setParentCubes(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPreviousGenerations

    void setPreviousGenerations(AssociationList list) throws RemoteException
    Sets the `PreviousGenerations` list to be `list`. Object of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPreviousGenerations

    void setPreviousGenerations(AssociationList list, int state) throws RemoteException
    Sets the `PreviousGenerations` list to be `list`. Object of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPreviousGeneration

    void setPreviousGeneration(Cube inObject) throws RemoteException
    Sets the `PreviousGenerations` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Cube
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReachThruTables

    void setReachThruTables(AssociationList list) throws RemoteException
    Sets the `ReachThruTables` list to be `list`. Objects of which can be of type:
    PhysicalTable
    WorkTable
    SecuredTable
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReachThruTables

    void setReachThruTables(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchemas

    void setAssociatedOLAPSchemas(AssociationList list) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list to be `list`. Objects of which can be of type:
    OLAPSchema
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchemas

    void setAssociatedOLAPSchemas(AssociationList list, int state) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list to be `list`. Objects of which can be of type:
    OLAPSchema
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAssociatedOLAPSchema

    void setAssociatedOLAPSchema(OLAPSchema inObject) throws RemoteException
    Sets the `AssociatedOLAPSchemas` list 0th element to be `inObject`.
    Parameters:
      `inObject` - OLAPSchema
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFormulas

    void setFormulas(AssociationList list) throws RemoteException
    Sets the `Formulas` list to be `list`. Objects of which can be of type:
    GlobalFormula
    NamedSet
    CalculatedMember
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setFormulas

    void setFormulas(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Formulas list to match the passed in AssociationList, sets the state of the Formulas
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMeasures

    void setMeasures(AssociationList list) throws RemoteException
    Sets the `Measures` list to be `list`. Objects of which can be of type:
    Measure
    CalculatedMeasure
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setMeasures

    void setMeasures(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Measures list to match the passed in AssociationList, sets the state of the Measures
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNextGenerations

    void setNextGenerations(AssociationList list) throws RemoteException
    Sets the `NextGenerations` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNextGenerations

    void setNextGenerations(AssociationList list, int state) throws RemoteException
    Sets the `NextGenerations` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setNextGeneration

    void setNextGeneration(Cube inObject) throws RemoteException
    Sets the `NextGenerations` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Cube
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSubCubes

    void setSubCubes(AssociationList list) throws RemoteException
    Sets the `SubCubes` list to be `list`. Objects of which can be of type:
    Cube
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSubCubes

    void setSubCubes(AssociationList inObjects, int state) throws RemoteException
    Sets the entire SubCubes list to match the passed in AssociationList, sets the state of the SubCubes
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.